#pragma once
//(  28  2007)
// ""    
// .   ,
//     .

//     
//,   


class CDinBuffer
{
	BYTE* m_pBUFF;//  

	DWORD m_dwdCurFullSize;//  
	DWORD m_dwdMaxFullSize;//,   
	DWORD m_dwdSizeStep;//  

	DWORD m_dwdDataLen;//    
	//m_dwdDataLen<=m_dwdCurFullSize

	public:
	CDinBuffer()
	{
		memset(this,0,sizeof(*this));
		//    SetParams
	}

	CDinBuffer(DWORD dwdBeginSize,DWORD dwdLimitSize,DWORD dwdSizeStep)
	{
		memset(this,0,sizeof(*this));

		SetParams(dwdBeginSize,dwdLimitSize,dwdSizeStep);
	}

	//  ,      :)
	void SetDataLenToZero()
	{
		m_dwdDataLen=0;
	}

	bool SetParams(DWORD dwdBeginSize,DWORD dwdLimitSize,DWORD dwdSizeStep)
	{
		if(!dwdLimitSize)return false;
		if(!dwdSizeStep)return false;

		ClearAndDeleteData();

		m_dwdMaxFullSize=dwdLimitSize;
		m_dwdCurFullSize=min(m_dwdMaxFullSize,dwdBeginSize);
		m_dwdSizeStep=min(m_dwdMaxFullSize,dwdSizeStep);
		m_pBUFF=new BYTE[m_dwdCurFullSize];

		if(m_pBUFF)
		{
			return true;
		}
		else
		{
			ClearAndDeleteData();
			return false;
		}

	}

	//    
	void ClearAndDeleteData()
	{
		if(m_pBUFF)
		{
			delete [] m_pBUFF;
			m_pBUFF=0;
		}
		memset(this,0,sizeof(*this));
	}

	//    
	// data_in==0,    dwdLen_in ,
	//  
	bool AddDataToEnd(const BYTE* data_in,const DWORD dwdLen_in)
	{
		//,    
		if(m_dwdDataLen+dwdLen_in>m_dwdCurFullSize)
		{
			if(!m_pBUFF)return false;

			// ,  

			//  
			__int64 qwNewSizeNeeded=m_dwdDataLen+dwdLen_in;

			//    ?
			if(qwNewSizeNeeded>(__int64)m_dwdMaxFullSize)return false;

			//qwNewSizeNeeded<=m_dwdMaxFullSize

			// ,   
			__int64 qwNewFullSize=m_dwdCurFullSize;
			for(;qwNewFullSize<qwNewSizeNeeded;)
			{
				qwNewFullSize+=m_dwdSizeStep;
			}

			//qwNewFullSize>=m_dwdMaxFullSize;

			//
			qwNewFullSize=min(qwNewFullSize,m_dwdMaxFullSize);

			//  -     
			if(qwNewSizeNeeded>(__int64)qwNewFullSize)return false;

			//qwNewSizeNeeded<=qwNewFullSize

			//:
			//  m_pBUFF[m_dwdCurFullSize]
			//  m_pBUFF[(DWORD)qwNewSizeNeeded]

			BYTE* pTemp= new BYTE[(DWORD)qwNewFullSize];
			if(!pTemp)return false;

			memmove(pTemp,m_pBUFF,m_dwdCurFullSize);

			m_dwdCurFullSize=(DWORD)qwNewFullSize;

			delete [] m_pBUFF;
			m_pBUFF=pTemp;
			pTemp=0;
		}

		// m_pBUFF!=0

		//, 

		//m_dwdDataLen
		//      |
		//012345~~~~~~~~~.......
		//               |
		//         m_dwdDataLen+dwdLen_in

		if(data_in)
		{
			// 
			memmove(&m_pBUFF[m_dwdDataLen],data_in,dwdLen_in);
		}
		else
		{
			// 
			memset(&m_pBUFF[m_dwdDataLen],0,dwdLen_in);
		}

		m_dwdDataLen+=dwdLen_in;
		return true;
	}

	DWORD GetDataLen()
	{
		if(m_pBUFF)return m_dwdDataLen;
		return 0;
	}

	const BYTE* GetBuffer()
	{
		return m_pBUFF;
	}

	~CDinBuffer()
	{
		ClearAndDeleteData();
	}
};

